#ifndef _fobject_h
#define _fobject_h

/*
  xut - button football (soccer) game
  Copyright (C) 2008 farrer <farrer@dnteam.org> and gushm <gushm@dnteam.org>

  This file is part of xut.

  xut is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  xut is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with xut.  If not, see <http://www.gnu.org/licenses/>.
*/

#define FOBJECT_TYPE_NONE          0
#define FOBJECT_TYPE_BALL          1
#define FOBJECT_TYPE_DISK          2
#define FOBJECT_TYPE_GOAL_KEEPER   3
#define FOBJECT_TYPE_GOAL_BEAM     4
#define FOBJECT_TYPE_GOAL_NET      5
#define FOBJECT_TYPE_FIELD         6
#define FOBJECT_TYPE_PUBLICITY     7

/*! The fobject is the base abstraction of interactive objects at the
 * game, like the ball, goals, disks, goal-keepers, etc. */
class fobject
{
   public:
      /*! Constructor */
      fobject(){type = FOBJECT_TYPE_NONE;};
      /*! Destructor */
      ~fobject(){};

      /*! Get the fobject type
       * \return -> fobject type constant */
      int getType(){return(type);};

   protected:
      int type;    /**< The fobject type */
};

#endif
