#ifndef _guimessage_h
#define _guimessage_h

/*
  xut - button football (soccer) game
  Copyright (C) 2008 farrer <farrer@dnteam.org> and gushm <gushm@dnteam.org>

  This file is part of xut.

  xut is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  xut is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with xut.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include <SDL/SDL_image.h>
#include <string>
using namespace std;

#include "../etc/options.h"

/*! The guiMessage class is simple a box where messages
 * texts are written to the users. */
class guiMessage
{
   public:
      /*! Constructor */
      guiMessage();

      /*! Destructor */
      ~guiMessage();

      /*! Quit the guiScore
       * \note -> must be called before quit the program. */
      void quit();

      /*! Draw the logo to the screen
       * \note -> projection must be 2D before this call */
      void draw();

      /*! Init the guiMessage to use
       * \param imageFile -> fileName of the image to use as back */
      void init(string imageFile);

      /*! Set the message on the guiMessage
       * \param msg -> string with message to show */
      void set(string msg);

   protected:
      options opt;
      static SDL_Surface* image;    /**< the back image */
      static GLuint texture;        /**< the defined texture */
      static GLfloat alpha;         /**< Current alpha of the message */
};


#endif

