#ifndef _guistatus_h
#define _guistatus_h

/*
  xut - button football (soccer) game
  Copyright (C) 2008 farrer <farrer@dnteam.org> and gushm <gushm@dnteam.org>

  This file is part of xut.

  xut is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  xut is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with xut.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include <SDL/SDL_image.h>
#include <string>
using namespace std;

#include "../etc/options.h"

/*! The gui Status class displays game current status
 * on the screen. */
class guiStatus
{
   public:
      /*! Constructor */
      guiStatus();
      /*! Destructor */
      ~guiStatus();

      /*! Draw the status to the screen
       * \note -> projection must be 2D before this call */
      void draw();

      /*! Free all structures
       * \note -> MUST be called before game exit */
      void quit();

      /*! Set the current remaining global touches */
      void setGlobalTouches(int touches);
      /*! Set the active team logo */
      void setActiveTeam(GLuint tlogo);

   protected:
 
      options opt;

      static GLuint activeTeamLogo;   /**< Active Team Logo */
      static GLuint statusTexture;    /**< The Status Texture */
      static bool statusAlloc;        /**< True if status texture is alloc */
};

#endif


