#ifndef _initial_h
#define _initial_h

/*
  xut - button football (soccer) game
  Copyright (C) 2008 farrer <farrer@dnteam.org> and gushm <gushm@dnteam.org>

  This file is part of xut.

  xut is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  xut is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with xut.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <SDL/SDL_opengl.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "../etc/cursor.h"
#include "../etc/options.h"


#define INITIAL_NEW      0
#define INITIAL_OPTIONS  1
#define INITIAL_EXIT     2

/*! Initial Menu */
class initial
{
   public:
      /*! Constructor 
       * \param proj -> projection matrix
       * \param modl -> modelView Matrix
       * \param vPort -> viewPort vector 
       * \param bg -> background texture */
      initial(GLdouble* proj,GLdouble* modl, GLint* vPort, GLuint bg);

      /*! Destructor */
      ~initial();

      /*! Run the menu
       * \param cursors -> current mouse cursors
       * \return -> item selected */
      int run(cursor* cursors);

   protected:
      /*! Draw the initial Screen
       * \param cursors -> mouse cursors */
      void draw(cursor* cursors);

      /*! Load All Text Textures */
      void loadTextTextures();

      options opt;

      GLdouble* projection;
      GLdouble* modelView;
      GLint* viewPort;

      int mouseX,             /**< Current MouseX */
          mouseY;             /**< Current MouseY */

      int current;            /**< Current selected */
      GLuint bgTexture;       /**< Background texture */

      GLuint textTexture[INITIAL_EXIT+1];   /**< All Text textures */
};



#endif

